From 50a7390f94b36598cc55e1db8900e9ddb43eb6e1 Mon Sep 17 00:00:00 2001
From: Benjamin Pisano <benjamin.pisano@icloud.com>
Date: Tue, 25 Jan 2022 11:32:17 +0100
Subject: [PATCH] fixed CI + added test for invalid image format + upgraded
 canvas to 2.9.0

---
 nodejs-tests/compareImages.test.js |    8 +-
 nodejs-tests/resemble.test.js      |    4 +-
 package-lock.json                  | 7126 ++++++++++++++++++++++++----
 package.json                       |    2 +-
 resemble.js                        |    7 +-
 5 files changed, 6317 insertions(+), 830 deletions(-)

diff --git a/nodejs-tests/compareImages.test.js b/nodejs-tests/compareImages.test.js
index 4626601..3d7b82c 100644
--- a/nodejs-tests/compareImages.test.js
+++ b/nodejs-tests/compareImages.test.js
@@ -34,7 +34,13 @@ describe("compareImages", () => {
 
     test("throws when failed", async () => {
         const promise = compareImages(fs.readFileSync("./demoassets/People.jpg"), "bogus data");
-        await expect(promise).rejects.toMatch("Error: ENOENT, No such file or directory 'bogus data'");
+        await expect(promise).rejects.toMatch("Failed to load image 'bogus data'. Error: ENOENT, No such file or directory 'bogus data'");
+    });
+
+    test("throws when invalid image format", async () => {
+        const invalidImageFormat = "data:,";
+        const promise = compareImages(invalidImageFormat, fs.readFileSync("./demoassets/People.jpg"));
+        await expect(promise).rejects.toMatch("Failed to load image 'data:,'. Error: Unsupported image type");
     });
 
     test("returns early", async () => {
diff --git a/nodejs-tests/resemble.test.js b/nodejs-tests/resemble.test.js
index 2d3e7f5..4ad507a 100644
--- a/nodejs-tests/resemble.test.js
+++ b/nodejs-tests/resemble.test.js
@@ -57,7 +57,9 @@ describe("resemble", () => {
             resemble("../demoassets/People.jpg")
                 .compareTo("../demoassets/404-image.jpg")
                 .onComplete((data) => {
-                    expect(data.error).toEqual("Error: ENOENT, No such file or directory '../demoassets/People.jpg'");
+                    expect(data.error).toEqual(
+                        "Failed to load image '../demoassets/People.jpg'. Error: ENOENT, No such file or directory '../demoassets/People.jpg'"
+                    );
                     resolve();
                 });
         }));
diff --git a/resemble.js b/resemble.js
index 32bcc10..86fc074 100644
--- a/resemble.js
+++ b/resemble.js
@@ -319,11 +319,8 @@ var isNode = function () {
             hiddenImage.onerror = function (event) {
                 hiddenImage.onload = null;
                 hiddenImage.onerror = null; // fixes pollution between calls
-                if (event.path && event.path[0]) {
-                    images.push({ error: `Failed to load image: ${event.path[0].currentSrc}`})
-                } else {
-                    images.push({ error: event ? `Failed to load image with error: ${event}` : "Failed to load image. Unknown error." });
-                }
+                const error = event ? event + "" : "Unknown error";
+                images.push({ error: `Failed to load image '${fileDataForImage}'. ${error}` });
                 callback();
             };
 
